// Generated by CoffeeScript 1.12.7
(function() {
  var Buffer, bs58, fn, hash, i, jsSHA, len, multihash, multihashing, ref, sha_type;

  jsSHA = require("jssha");

  multihashing = require('multihashing');

  Buffer = require('buffer/').Buffer;

  bs58 = require('bs58');

  module.exports = {};

  hash = function(text, algorithm) {
    var bits, ref, shaObj;
    if (!algorithm) {
      throw new Error("No algorithm specified");
    }
    bits = (ref = algorithm.match(/^sha-?(\d+)$/i)) != null ? ref[1] : void 0;
    if (!bits) {
      throw new Error("Unknown algorithm '" + algorithm + "'");
    }
    algorithm = "SHA-" + bits;
    shaObj = new jsSHA(algorithm, "TEXT");
    shaObj.update(text);
    return shaObj.getHash("HEX");
  };

  multihash = function(data, algorithm) {
    var buffer, digest;
    if (algorithm == null) {
      algorithm = 'sha2-256';
    }
    buffer = new Buffer(data);
    digest = multihashing(buffer, algorithm);
    return bs58.encode(digest);
  };

  module.exports = {
    hash: hash,
    multihash: multihash
  };

  ref = [1, 224, 256, 384, 512];
  fn = function(sha_type) {
    var algorithm;
    algorithm = "sha" + sha_type;
    return module.exports[algorithm] = function(text) {
      return hash(text, algorithm);
    };
  };
  for (i = 0, len = ref.length; i < len; i++) {
    sha_type = ref[i];
    fn(sha_type);
  }

}).call(this);
